# Every Developer Should Know :thinking:
A collection of (mostly) technical things every software developer should know.  
Highly opinionated :bomb:. Not backed by science.  
Comes in no particular order :recycle:

---- 

### Floating Point
- [Floating Point Guide](http://floating-point-gui.de/)

### Strings
- [Big List of Naughty Strings](https://github.com/minimaxir/big-list-of-naughty-strings)
- :page_facing_up: [Unicode and Character Sets](http://www.joelonsoftware.com/articles/Unicode.html)
- [Homoglyphs](https://github.com/codebox/homoglyph/)
- [Unicode Common Locale Data Repository](http://cldr.unicode.org/)

### Latency 
- [Interactive Latency Infographics](https://people.eecs.berkeley.edu/~rcs/research/interactive_latency.html)

### Time
- :page_facing_up: [Falsehoods programmers believe about time](http://infiniteundo.com/post/25326999628/falsehoods-programmers-believe-about-time)
- :page_facing_up: [More falsehoods programmers believe about time; “wisdom of the crowd” edition](http://infiniteundo.com/post/25509354022/more-falsehoods-programmers-believe-about-time)
- :page_facing_up: [Some notes about time](https://unix4lyfe.org/time/?v=1)

### Memory
- :page_facing_up: [What every Programmer should know about memory](http://lwn.net/Articles/250967/)

### Distributed Systems
- :scroll: [Designs, Lessons and Advice from Building Large Distributed Systems](http://www.cs.cornell.edu/projects/ladis2009/talks/dean-keynote-ladis2009.pdf)
- :scroll: [Time, Clocks and the Ordering of Events in a Distributed System](https://www.microsoft.com/en-us/research/publication/time-clocks-ordering-events-distributed-system/?from=http%3A%2F%2Fresearch.microsoft.com%2Fen-us%2Fum%2Fpeople%2Flamport%2Fpubs%2Ftime-clocks.pdf)
- :page_facing_up: [There is No Now](http://queue.acm.org/detail.cfm?id=2745385)

### RegExp
- [RegexHQ](https://github.com/regexhq)

### Arhitecture
- :scroll: [A Field Guide to Boxology](http://web.cs.wpi.edu/~cs562/s98/pdf/Boxology.pdf)
- :scroll: [Out of the Tar Pit](https://github.com/papers-we-love/papers-we-love/blob/master/design/out-of-the-tar-pit.pdf?raw=true)
- :scroll: [No Silver Bullet — Essence and Accidents of Software Engineering](http://faculty.salisbury.edu/~xswang/Research/Papers/SERelated/no-silver-bullet.pdf)
- :movie_camera: [Growing a Language](https://www.youtube.com/watch?v=_ahvzDzKdB0)
- :movie_camera: [CQRS and Event Sourcing](https://www.youtube.com/watch?v=JHGkaShoyNs)

### Practices
- :book: [Working Effectively with Legacy Code](https://www.goodreads.com/book/show/44919.Working_Effectively_with_Legacy_Code)
- :book: [Test Driven Development: By Example](https://www.goodreads.com/book/show/387190.Test_Driven_Development)
- :white_check_mark: [Going To Production Checklist](https://github.com/mr-mig/going-to-production)

### Career 
- :page_facing_up: [How Much Do Software Engineers Really Make in Each City?](https://www.codementor.io/blog/best-cities-software-engineer-earnings-271vpf599k)
- :page_facing_up: [Software Engineers Tenure in San Francisco](https://hackerlife.co/blog/san-francisco-large-corporation-employee-tenure)
- [Software Engineering 101](slides.com/mr-mig/se101)
- :book: [The Passionate Programmer](https://www.goodreads.com/book/show/6399113-the-passionate-programmer)
- :book: [Soft Skills: The software developer's life manual](https://www.goodreads.com/book/show/23232941-soft-skills)
- :book: [Programming Beyond Practices: Be More Than Just a Code Monkey](https://www.goodreads.com/book/show/29895093-programming-beyond-practices)

### Engineering Philosophy
- :movie_camera: [Simple Made Easy](https://www.infoq.com/presentations/Simple-Made-Easy)

### Papers on Programming 
- :heart: [Papers We Love](https://github.com/papers-we-love/papers-we-love) 
- :newspaper: [The Morning Paper](https://blog.acolyer.org/)

### Free Books on Programming
- [Free Programming Books](https://github.com/EbookFoundation/free-programming-books)
